package gl

/*
#include "gl.h"
*/
import "C"

type Enum C.GLenum
type Bitfield C.GLbitfield
type Clampf C.GLclampf
type Shader C.GLuint
type Program C.GLuint
type Uniform C.GLuint
type Attribute C.GLuint
type Boolean C.GLboolean
type Texture C.GLuint
type Buffer C.GLuint
type VBO Buffer
type VAO C.GLuint

const (
	GLEW_OK  Enum = C.GLEW_OK
	NO_ERROR Enum = C.GL_NO_ERROR
)

const (
	FLOAT  Enum = C.GL_FLOAT
	DOUBLE Enum = C.GL_DOUBLE
)

const (
	FALSE Boolean = C.GL_FALSE
	TRUE  Boolean = C.GL_TRUE
)

const (
	COLOR_BUFFER_BIT   Bitfield = C.GL_COLOR_BUFFER_BIT
	DEPTH_BUFFER_BIT   Bitfield = C.GL_DEPTH_BUFFER_BIT
	ACCUM_BUFFER_BIT   Bitfield = C.GL_ACCUM_BUFFER_BIT
	STENCIL_BUFFER_BIT Bitfield = C.GL_STENCIL_BUFFER_BIT
)

const (
	VERTEX_SHADER   Enum = C.GL_VERTEX_SHADER
	FRAGMENT_SHADER Enum = C.GL_FRAGMENT_SHADER
	GEOMETRY_SHADER Enum = C.GL_GEOMETRY_SHADER
)

const (
	COMPILE_STATUS Enum = C.GL_COMPILE_STATUS
	LINK_STATUS    Enum = C.GL_LINK_STATUS
)

const (
	INFO_LOG_LENGTH Enum = C.GL_INFO_LOG_LENGTH
)

const (
	TEXTURE_1D Enum = C.GL_TEXTURE_1D
	TEXTURE_2D Enum = C.GL_TEXTURE_2D
	TEXTURE_3D Enum = C.GL_TEXTURE_3D
)

const (
	MAX_TEXTURE_IMAGE_UNITS Enum = C.GL_MAX_TEXTURE_IMAGE_UNITS
	MAX_VERTEX_ATTRIBS      Enum = C.GL_MAX_VERTEX_ATTRIBS
	MAX_TEXTURE_COORDS      Enum = C.GL_MAX_TEXTURE_COORDS
	MAX_TEXTURE_SIZE        Enum = C.GL_MAX_TEXTURE_SIZE
)

const (
	MAX_VERTEX_UNIFORM_COMPONENTS   Enum = C.GL_MAX_VERTEX_UNIFORM_COMPONENTS
	MAX_FRAGMENT_UNIFORM_COMPONENTS Enum = C.GL_MAX_FRAGMENT_UNIFORM_COMPONENTS

	MAX_VARYING_FLOATS Enum = C.GL_MAX_VARYING_FLOATS
)

const (
	ARRAY_BUFFER              Enum = C.GL_ARRAY_BUFFER
	COPY_READ_BUFFER          Enum = C.GL_COPY_READ_BUFFER
	COPY_WRITE_BUFFER         Enum = C.GL_COPY_WRITE_BUFFER
	PIXEL_PACK_BUFFER         Enum = C.GL_PIXEL_PACK_BUFFER
	PIXEL_UNPACK_BUFFER       Enum = C.GL_PIXEL_UNPACK_BUFFER
	TEXTURE_BUFFER            Enum = C.GL_TEXTURE_BUFFER
	TRANSFORM_FEEDBACK_BUFFER Enum = C.GL_TRANSFORM_FEEDBACK_BUFFER
	UNIFORM_BUFFER            Enum = C.GL_UNIFORM_BUFFER
	ELEMENT_ARRAY_BUFFER      Enum = C.GL_ELEMENT_ARRAY_BUFFER
)

const (
	BUFFER_ACCESS Enum = C.GL_BUFFER_ACCESS
	BUFFER_MAPPED Enum = C.GL_BUFFER_MAPPED
	BUFFER_SIZE   Enum = C.GL_BUFFER_SIZE
	BUFFER_USAGE  Enum = C.GL_BUFFER_USAGE
)

const (
	RGBA   Enum = C.GL_RGBA
	BGRA   Enum = C.GL_BGRA
	RGBA16 Enum = C.GL_RGBA16
)

const (
	SHORT          Enum = C.GL_SHORT
	UNSIGNED_BYTE  Enum = C.GL_UNSIGNED_BYTE
	UNSIGNED_SHORT Enum = C.GL_UNSIGNED_SHORT
	UNSIGNED_INT   Enum = C.GL_UNSIGNED_INT
)

const (
	VENDOR                   Enum = C.GL_VENDOR
	RENDERER                 Enum = C.GL_RENDERER
	VERSION                  Enum = C.GL_VERSION
	SHADING_LANGUAGE_VERSION Enum = C.GL_SHADING_LANGUAGE_VERSION
	EXTENSIONS               Enum = C.GL_EXTENSIONS
)

const (
	BLEND Enum = C.GL_BLEND
)

const (
	SRC_ALPHA           Enum = C.GL_SRC_ALPHA
	ONE_MINUS_SRC_ALPHA Enum = C.GL_ONE_MINUS_SRC_ALPHA
)

const (
	STATIC_DRAW  Enum = C.GL_STATIC_DRAW
	DYNAMIC_DRAW Enum = C.GL_DYNAMIC_DRAW
)

const (
	MAP_WRITE_BIT Bitfield = C.GL_MAP_WRITE_BIT
)

const (
	LINES     Enum = C.GL_LINES
	TRIANGLES Enum = C.GL_TRIANGLES
)

const (
	TEXTURE0 Enum = C.GL_TEXTURE0
)

const (
	NEAREST = C.GL_NEAREST
	LINEAR  = C.GL_LINEAR
)

const (
	CLAMP  = C.GL_CLAMP
	REPEAT = C.GL_REPEAT
)

const (
	TEXTURE_WRAP_S     Enum = C.GL_TEXTURE_WRAP_S
	TEXTURE_WRAP_T     Enum = C.GL_TEXTURE_WRAP_T
	TEXTURE_MIN_FILTER Enum = C.GL_TEXTURE_MIN_FILTER
	TEXTURE_MAG_FILTER Enum = C.GL_TEXTURE_MAG_FILTER
)

const (
	COMPRESSED_RGBA_S3TC_DXT1 = C.GL_COMPRESSED_RGBA_S3TC_DXT1_EXT
	COMPRESSED_RGBA_S3TC_DXT3 = C.GL_COMPRESSED_RGBA_S3TC_DXT3_EXT
	COMPRESSED_RGBA_S3TC_DXT5 = C.GL_COMPRESSED_RGBA_S3TC_DXT5_EXT
)

const (
	CULL_FACE      Enum = C.GL_CULL_FACE
	FRONT          Enum = C.GL_FRONT
	BACK           Enum = C.GL_BACK
	FRONT_AND_BACK Enum = C.GL_FRONT_AND_BACK
	DEPTH_TEST     Enum = C.GL_DEPTH_TEST
)

const (
	POINT Enum = C.GL_POINT
	LINE  Enum = C.GL_LINE
	FILL  Enum = C.GL_FILL
)
